/* ident.h of iplog v1.5 -- eric@ojnk.org */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <netdb.h>
#include <signal.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>

#define TCP_LISTEN      0x0A
#define TCP_FORMAT      "%*d: %*X:%x %*X:%*x %x %*X:%*X %*x:%*X %*x %*d %*d %*d"
#define TCP_DATA        "/proc/net/tcp"

#define IDENTD_FORMAT	"%*d , %*d : USERID : %*s : %64s"
#define	IDENTD_PORT     FIX(113)
#define FTP_PORT        FIX(20)

char *get_identd_data(u_short r_port, u_short l_port, u_long r_addr, u_long l_addr)
{
	fd_set fd_read;
	int s, on = 1;
	struct linger lin =
	{0, 0};
	struct timeval tv =
	{10, 0};
	struct sockaddr_in sin;
	static char *user = NULL;
	char buf[512], temp[64];

	if ((s = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) != (-1L)) {
		(void)setsockopt(s, SOL_SOCKET, SO_LINGER, &lin, sizeof(lin));
		(void)setsockopt(s, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on));

		memset((char *)&sin, 0, sizeof(sin));
		sin.sin_family = AF_INET;
		sin.sin_addr.s_addr = l_addr;
		sin.sin_port = INADDR_ANY;

		if (bind(s, (struct sockaddr *)&sin, sizeof(sin)) != INADDR_NONE) {
			memset((char *)&sin, 0, sizeof(sin));
			sin.sin_family = AF_INET;
			sin.sin_port = IDENTD_PORT;
			sin.sin_addr.s_addr = r_addr;

			if (connect(s, (struct sockaddr *)&sin, sizeof(sin)) != INADDR_NONE) {
				sprintf(buf, "%d , %d\r\n", UNFIX(r_port), UNFIX(l_port));
				send(s, buf, strlen(buf), 0);
				memset(buf, 0, sizeof(buf));
				memset(temp, 0, sizeof(temp));

				FD_ZERO(&fd_read);
				FD_SET(s, &fd_read);

				if (select(s + 1, &fd_read, NULL, NULL, &tv) > 0)
					if (recv(s, buf, 512, 0) > 0)
						if (sscanf(buf, IDENTD_FORMAT, temp) > 0)
							user = strdup(temp);

				(void)close(s);
			}
		}
	}
	return (user);
}


/* Check if a local port "port" is listening--if the connection was refused,
   identd on the remote host has closed the connection and thus has no data
   on the connection, which makes attempting to get the ident reply stupid. */

int l_port(u_short port)
{
	FILE *fp;
	unsigned int l_port, mode;
	char buf[BUFSIZ];

	if ((fp = fopen(TCP_DATA, "r")) == NULL)
		return 0;

	while (fgets(buf, sizeof(buf) - 1, fp) != NULL)
		if ((sscanf(buf, TCP_FORMAT, &l_port, &mode) == 2) && (UNFIX(l_port) == port) && (mode == TCP_LISTEN))
			break;

	(void)fclose(fp);

	if ((UNFIX(l_port) == port) && (mode == TCP_LISTEN))
		return 1;

	return 0;
}
